/*
 * PhysicsTest
 *
 * Written by Soothsayer in January 2010
 *
 * Website: http://www.cppanddelphi.atw.hu
 * Contact: cppanddelphi@gmail.com
 */
unit TMatrix;

interface

uses
  TVector;

type
  CMatrix = record
    Col1, Col2: CVector;
  end;

  function CreateM(const AAngle: Single):CMatrix;
  function MultiplyM(const A: CMatrix; const V: CVector): CVector; overload;

implementation

function CreateM(const AAngle: Single): CMatrix;
var
  C, S: Single;
begin
  C := Cos(AAngle); S := Sin(AAngle);
  Result.Col1.X :=  C;
  Result.Col2.X := -S;
  Result.Col1.Y :=  S;
  Result.Col2.Y :=  C;
end;

function MultiplyM(const A: CMatrix; const V: CVector): CVector;
begin
  Result.X := (A.Col1.X * V.X) + (A.Col2.X * V.Y);
  Result.Y := (A.Col1.Y * V.X) + (A.Col2.Y * V.Y);
end;

end.
